#include <map>
#include <math.h>

static const int sample_rate      = 32000;
static const double ticks_per_sec = 60.098813897440515532;

static const double silence_level = 1/64.0;

struct ch 
{
    double hz, amplitude;
    
    bool operator==(const ch& b) const
    {
        const double ampli_diff = fabs(amplitude - b.amplitude);
        
        /*
        const double tone_1 = log(  hz)*12.0/log_2;
        const double tone_2 = log(b.hz)*12.0/log_2;
        const double tone_diff  = fabs(tone_1 - tone_2);
        */
        const double octave_diff = fabs(log2(hz)-log2(b.hz));
        
        //fprintf(stderr, "amplidiff %g, octadiff %g\n", ampli_diff, octave_diff);
        
        return ampli_diff  < (1  /16.0)    // 1/16 of full volume
            && octave_diff < (1.3/12.0); // 1 seminote
    }
    bool operator!=(const ch& b) const { return !operator==(b); }
};
typedef std::map<unsigned, ch> situation;
